# QuaternionSpline

#### new Cesium.QuaternionSpline(options)
Core/QuaternionSpline.js 49

A spline that uses spherical linear (slerp) interpolation to create a quaternion curve. The generated curve is in the class C1.

Name | Type | Description
--- | --- | ---
`options` | Object | Object with the following properties:
Name | Type | Description
--- | --- | ---
`times` | Array.<Number> | An array of strictly increasing, unit-less, floating-point times at each point. The values are in no way connected to the clock time. They are the parameterization for the curve.
`points` | Array.<Quaternion> | The array of `Quaternion` control points.

##### Throws:

- DeveloperError : points.length must be greater than or equal to 2.
- DeveloperError : times.length must be equal to points.length.

##### See:

- HermiteSpline
- CatmullRomSpline
- LinearSpline
- WeightSpline

### Members

#### readonly points : Array.<Quaternion>
Core/QuaternionSpline.js 99

An array of `Quaternion` control points.

#### readonly times : Array.<Number>
Core/QuaternionSpline.js 85

An array of times for the control points.

### Methods

#### clampTime(time) → Number
Core/QuaternionSpline.js 136

Clamps the given time to the period covered by the spline.

Name | Type | Description
--- | --- | ---
`time` | Number | The time.

##### Returns:

The time, clamped to the animation period.

#### evaluate(time, result) → Quaternion
Core/QuaternionSpline.js 149

Evaluates the curve at a given time.

Name | Type | Description
--- | --- | ---
`time` | Number | The time at which to evaluate the curve.
`result` | Quaternion | optional The object onto which to store the result.

##### Returns:

The modified result parameter or a new instance of the point on the curve at the given time.

##### Throws:

- DeveloperError : time must be in the range `[t0, tn]`, where `t0` is the first element in the array `times` and `tn` is the last element in the array `times`.

#### findTimeInterval(time) → Number
Core/QuaternionSpline.js 118

Finds an index `i` in `times` such that the parameter `time` is in the interval `[times[i], times[i + 1]]`.

Name | Type | Description
--- | --- | ---
`time` | Number | The time.

##### Returns:

The index for the element at the start of the interval.

##### Throws:

- DeveloperError : time must be in the range `[t0, tn]`, where `t0` is the first element in the array `times` and `tn` is the last element in the array `times`.

#### wrapTime(time) → Number
Core/QuaternionSpline.js 127

Wraps the given time to the period covered by the spline.

Name | Type | Description
--- | --- | ---
`time` | Number | The time.

##### Returns:

The time, wrapped around to the updated animation.